c====================================================================
c= Program Sort (Examples of sorting algorithms)  file = ex18_1.f   =
c= Ken Christensen  XXX-XX-XXXX                                     =
c====================================================================
c= This program calls subroutines to sort a vector                  =
c=   - SORT1() implements a selection sort                          =
c=   - SORT2() implements a bubble sort                             =
c====================================================================
c= Variables used are:                                              =
c=   X     : Integr vector                                          =
c=   LEN   : Length (dimension) of X                                =
c=   J     : Loop counter                                           =
c====================================================================
c= Program inputs are: None                                         =
c= Program outputs are: X after call to a sort subroutine           =
c====================================================================

      INTEGER X(1000), LEN, J

      X(1) = 3
      X(2) = 1
      X(3) = 4
      X(4) = 2
      X(5) = 6
      X(6) = 5
      LEN  = 6

      CALL SORT1(X, LEN)

      DO 10 J = 1, LEN
        PRINT *, 'X(',J,') = ', X(J)
10    CONTINUE

      END

c====================================================================
c= Selection sort                                                   =
c====================================================================
      SUBROUTINE SORT1(X, LEN)
      INTEGER LEN, X(LEN), J, K, MIN, LOCMIN

      DO 20 J = 1, LEN - 1
        MIN = X(J)
        LOCMIN = J
        DO 10 K = J + 1, LEN
          IF (X(K).LT.MIN) THEN
            MIN = X(K)
            LOCMIN = K
          ENDIF
10      CONTINUE
        X(LOCMIN) = X(J)
        X(J) = MIN
20    CONTINUE

      END

c====================================================================
c= Bubble sort                                                      =
c====================================================================
      SUBROUTINE SORT2(X, LEN)
      INTEGER LEN, X(LEN), PAIRS, LAST, J, TEMP

      PAIRS = LEN - 1

10    IF (PAIRS.GT.0) THEN
        LAST = 1
        DO 20 J = 1, PAIRS
          IF (X(J).GT.X(J + 1)) THEN
            TEMP = X(J)
            X(J) = X(J + 1)
            X(J + 1) = TEMP
            LAST = J
          ENDIF
20      CONTINUE

        PAIRS = LAST - 1

        GOTO 10
      ENDIF

      END
